#ifndef LCD4_H
#define	LCD4_H
//------------------------------------------------------------------------------#include <xc.h> 
#include "Lcd4_prototypes.h"
#include "74HC595.h"
//-----------------------Follow Datasheet instructions--------------------------
void LCD_init()
{
  SR_init();

  LCD_command(home);
  LCD_command(function_set);   
  LCD_command(display_on);      
  LCD_command(auto_increment);
}
//------------------------------------------------------------------------------
void LCD_command(char command)
{
  RS = 0;                         //Instruction register ( commands ).
  LCD_write(command);
}
//------------------------------------------------------------------------------
void LCD_data(char data)
{
  RS = 1;                          //Data register ( Strings and characters ).
  LCD_write(data);
}
//------------------------------------------------------------------------------
void LCD_string(char row, char column, char text[])
{
  LCD_command(rowAddr[row] + column);  //Set co-ordinates.
  while(*text)
  {
    LCD_data(*text++);
  }
}
//------------------------------------------------------------------------------
void LCD_write(char data)
{
  LCD_sendNibble(data & 0xF0);      //Higher Nibble
  LCD_sendNibble(data << 4);        //Lower Nibble
}
//------------------------------------------------------------------------------
void LCD_sendNibble(char data)
{
  data = (data | RS);
  
  //Enable is pulsed to latch the data
  SR_transmit(data | EN_high);
  __delay_us(5);
  SR_transmit(data & EN_low);
}
//------------------------------------------------------------------------------
#endif