#ifndef SYNCHRONOUS_USART_H
#define	SYNCHRONOUS_USART_H
//------------------------------------------------------------------------------
__bit bt;
//------------------------------------------------------------------------------
void USART_init(unsigned int baudRate)
{
   TXSTA = 0xB0;   // Master mode, Set TXEN,SYNC = 1:Synchronous mode
   RCSTA = 0x80;   //Set SPEN.
   SPBRG = (int)((_XTAL_FREQ/baudRate)/4) - 1; //Formula according to Datasheet (For Highspeed mode)
   
   TRISB1 = 1;     //DT
   TRISB2 = 1;     //CK
}
//------------------------------------------------------------------------------
char USART_swapBits(char data)
{
  char send = 0; 
  
  for(int Tx = 0 ; Tx < 8 ; Tx++ )
  {
    bt = ( (data << Tx) & 0x80 ) ? 1 : 0 ; 
    send +=  bt << Tx;             //Swap register from MSB to LSB
  }
  
  return send;
}
//------------------------------------------------------------------------------
void USART_Write(char data)
{
  data = USART_swapBits(data);     //...Because USART transmits LSB first  
  
  while(!TRMT);  
  TXREG = data;
}
//------------------------------------------------------------------------------
char USART_Read()
{
   while(!RCIF);
   return RCREG;
}
//------------------------------------------------------------------------------
#endif